"""Ferda related context processors."""

from ferda.plugins import CONFIG


def ferda_modules(request):
    """Return context variables with ferda modules config."""
    if request.resolver_match.app_names:
        current_app = request.resolver_match.app_names[0]  # app_names[0] is app_name from urls.py
    else:
        current_app = None

    ferda_plugins = {}
    for app_name, config in reversed(CONFIG.items()):
        if config.access(request.user):
            config_dict = config.dict()
            config_dict.pop("access")
            config_dict.pop("permissions")
            ferda_plugins[app_name] = config_dict

    context = {
        "ferda_plugins": ferda_plugins,
        "current_plugin": current_app,
        "current_plugin_name": CONFIG[current_app].name if current_app in CONFIG else None,
    }
    return context
